Index: main/rules/org/drools/examples/sudoku/sudokuSolverValidatorWithGuess.drl
===================================================================
--- main/rules/org/drools/examples/sudoku/sudokuSolverValidatorWithGuess.drl	(revision 0)
+++ main/rules/org/drools/examples/sudoku/sudokuSolverValidatorWithGuess.drl	(revision 0)
@@ -0,0 +1,1026 @@
+package org.drools.examples.sudoku
+
+import org.drools.examples.sudoku.rules.RemovedCellValue;
+import org.drools.examples.sudoku.rules.GuessedCellValue;
+import org.drools.examples.sudoku.rules.PossibleCellValue;
+import org.drools.examples.sudoku.rules.ResolvedCellValue;
+import org.drools.examples.sudoku.rules.SudokuStatusUnresolved;
+import org.drools.examples.sudoku.rules.SudokuStatusConflict;
+import org.drools.examples.sudoku.rules.SudokuStatusSolved;
+import org.drools.examples.sudoku.rules.BaseCell;
+
+global org.drools.examples.sudoku.rules.ResolvedCellValue resolved;
+
+/**
+ * This rule package defines a set of rules that can be used to solve a partially filled Sudoku grid.
+ * It expects to have objects of type PossibleCellValue and ResolvedCellValue
+ * inserted into the working memory and will then work to remove PossibleCellValues and to 
+ * insert ResolvedCellValues until a single ResolvedCellValue is present for each row and column
+ * and not PossibleCellValues remain.
+ *
+ * Any issues discovered are inserted as Strings into the issues global.
+ *
+ * @author <a href="pbennett@redhat.com">Pete Bennett</a>
+ * @author <a href="mailto:michael.frandsen@syngenio.de">Michael Frandsen</a>
+ * @version $Revision: 1.1 $
+ */
+/**
+ * The 	agenda-group "BaseTest" is the basic set of rules needed to solve a sudoku problem
+ * that doesn't involve guessing-testing loops.
+ */
+ 
+
+/**
+ * This rule checks for the situation where a given Cell in the Sudoku Grid has been assigned 
+ * a definate ResolvedCellValue (i.e. we know what the value in this cell of the Grid is) and
+ * removes any other possible values from this cell (i.e. instances of PossibleCellValue 
+ * with the same row and column.
+ */
+rule "BaseTest: #01 once a specific cell has a ResolvedCellValue, remove all the other PossibleCellValues for the same cell"
+	# this rule requires a high salience so that, when it is activated it is executed, as soon as a 
+	# ResolvedCellValue is set, we need to clear out the PossibleCellValues for the same cell location, 
+	# otherwise other rules misfire - a good example of a valid use for salience
+	agenda-group "BaseTest"
+	salience 50 
+	when
+	    # matches all ResolvedCellValues (RCVs) in the grid, and stores them in the $resolved local variable
+	    # note that we also need to store the row and column for $resolved in $resolvedRow and $resolvedColum
+	    # so that the second part of the when clause can access them
+		$resolved : ResolvedCellValue($resolvedRow : row, $resolvedCol : col)
+		
+		# matches any PossibleCellValues (PCVs) in the grid with the same row and column as $resolved
+		$possible : PossibleCellValue(row == $resolvedRow, col == $resolvedCol)
+	then
+		# remove the matching PCVs stored in $possible
+		retract($possible);
+		
+		# trigger an update for the matched RCV stored in $resolved
+		update ($resolved); # this is done so that listeners can be triggered to know this cell is now resolved
+		
+		# insert a new String into the working memory describing in detail what we have done
+		insert ("BaseTest: rule #1 cleared the other PossibleCellValues for ("+$resolved.getRow()+","+$resolved.getCol()+") as a ResolvedCellValue of "+$resolved.getValue()+" exists for this cell.");
+end
+
+/** 
+ * This rule checks for the situation where a given Cell in the SudokuGrid only has 
+ * one PossibleCellValue assigned to its row and column. Once we have this situation, we 
+ * now that this must be the correct value for the cell so we remove the single PossibleCellValue
+ * and replace it with an equivalent ResolvedCellValue.
+ */
+rule "BaseTest: #02 If a cell has only a single PossibleCellValue, remove it and replace it with the equivalent ResolvedCellValue"
+	agenda-group "BaseTest"
+	salience 35
+	when
+		# macthes all PCVs in the Grid, stores them in $possible
+		$possible : PossibleCellValue ( $possibleRow : row, $possibleCol : col, $possibleValue : value )
+		
+		# the not operator only causes this when clause to resolve to true when there are not
+		# any other PCVs with the same row and column but different values to $possible
+		not ( PossibleCellValue ( row == $possibleRow, col == $possibleCol, value != $possibleValue ) )
+	then
+		# remove $possible from the working memory
+		retract($possible);
+		
+		# insert a new ResolvedCellValue with the same row, column and value into the working memory
+		insert (new ResolvedCellValue($possible));
+
+		# insert a new String into the working memory describing in detail what we have done
+		insert ("BaseTest: rule #2 changed the only PossibleCellValue at ("+$possible.getRow()+","+$possible.getCol()+") to a ResolvedCellValue with the value of "+$possible.getValue());
+end
+
+/**
+ * This rule checks for the situation where a row in the Grid has a ResolvedCellValue in it. In 
+ * this case we know that the value can not occur in any of the other cells in the same row in 
+ * the grid, so we look for any PossibleCellValues with the same row and remove them.
+ */
+rule "BaseTest: #03 If a row has a ResolvedCellValue in it, remove this value as a PossibleCellValue from all other cells in the same row"
+	agenda-group "BaseTest"
+  	salience 40
+  	when
+  		# matches all RCVs in the grid, and stores them in the $resolved local variable		
+		$resolved : ResolvedCellValue( $resolvedRow : row, $resolvedValue : value )
+		
+		# matches all the PCVs in the grid in the same row with the same value as $resolved
+		$possible : PossibleCellValue( row == $resolvedRow, value == $resolvedValue )
+	then
+		retract($possible);
+
+		# insert a new String into the working memory describing in detail what we have done
+		insert ("BaseTest: rule #3 determined the value at ("+$possible.getRow()+","+$possible.getCol()+") could not be "+$possible.getValue()+" as this value already exists in the same row at ("+$resolved.getRow()+","+$resolved.getCol()+")");
+end
+
+/**
+ * This rule checks for the situation where a column in the Grid has a ResolvedCellValue in it. In 
+ * this case we know that the value can not occur in any of the other cells in the same column in 
+ * the grid, so we look for any PossibleCellValues with the same column and remove them.
+ */
+rule "BaseTest: #04 If a column has a ResolvedCellValue in it, remove this value as a PossibleCellValue from all other cells in the same column"
+	agenda-group "BaseTest"
+  	salience 40
+    when		
+  		# matches all RCVs in the grid, and stores them in the $resolved local variable		
+		$resolved : ResolvedCellValue( $resolvedCol : col, $resolvedValue : value )
+
+		# matches all the PCVs in the grid in the same column with the same value as $resolved
+		$possible : PossibleCellValue( col == $resolvedCol, value == $resolvedValue )
+	then
+		retract($possible);
+
+		# insert a new String into the working memory describing in detail what we have done
+		insert ("BaseTest: rule #4 determined the value at ("+$possible.getRow()+","+$possible.getCol()+") could not be "+$possible.getValue()+" as this value already exists in the same column at ("+$resolved.getRow()+","+$resolved.getCol()+")");
+end
+
+/**
+ * This rule checks for the situation where a zone in the Grid has a ResolvedCellValue in it. In 
+ * this case we know that the value can not occur in any of the other cells in the same zone in 
+ * the grid, so we look for any PossibleCellValues with the same zone and remove them.
+ */
+rule "BaseTest: #05 If a zone has a ResolvedCellValue in it, remove this value as a PossibleCellValue from all other cells in the same zone"
+	agenda-group "BaseTest"
+  	salience 40
+ 	when		
+  		# matches all RCVs in the grid, and stores them in the $resolved local variable		
+		$resolved : ResolvedCellValue( $resolvedZone : zone, $resolvedValue : value )
+
+		# matches all the PCVs in the grid in the same zone with the same value as $resolved
+		$possible : PossibleCellValue( zone == $resolvedZone, value == $resolvedValue )
+	then
+		retract($possible);
+
+	    # insert a new String into the working memory describing in detail what we have done
+		insert ("BaseTest: rule #5 determined the value at ("+$possible.getRow()+","+$possible.getCol()+") could not be "+$possible.getValue()+" as this value already exists in the same zone at ("+$resolved.getRow()+","+$resolved.getCol()+")");
+end
+
+/**
+ * This rule checks for the situation when it is only possible for one cell of a row in the Grid to contain
+ * a particular value, i.e. there is exactly one PossibleCellValue with a given value and a given row.
+ * In this case, this cell must actually contain the value so we remove the single PossibleCellValue
+ * and replace it with an equivalent ResolvedCellValue.
+ */
+rule "BaseTest: #06 If a PossibleCellValue only appears once in a row, then this must be the ResolvedCellValue"
+	agenda-group "BaseTest"
+    salience 30
+	when
+		# matches all PCVs in the grid, and stores them in the $possible local variable		
+		$possible : PossibleCellValue( $zone : zone, $value : value, $col : col, $row : row)
+
+		# the not operator only causes this when clause to resolve to true when there are not
+		# any other PCVs with the same row and value as $possible
+		not (PossibleCellValue( row == $row, value == $value ))
+	then
+		retract($possible);
+		insert (new ResolvedCellValue($possible));
+
+		# insert a new String into the working memory describing in detail what we have done
+		insert ("BaseTest: rule #6 determined ("+$row+","+$col+") is "+$value+" as this is the only possible cell in the row that can have this value");
+end
+
+/**
+ * This rule checks for the situation when it is only possible for one cell of a column in the Grid to contain
+ * a particular value, i.e. there is exactly one PossibleCellValue with a given value and a given column.
+ * In this case, this cell must actually contain the value so we remove the single PossibleCellValue
+ * and replace it with an equivalent ResolvedCellValue.
+ */
+rule "BaseTest: #07 If a PossibleCellValue only appears once in a column, then this must be the ResolvedCellValue"
+	agenda-group "BaseTest"
+    salience 30
+  	when		
+		# matches all PCVs in the grid, and stores them in the $possible local variable		
+		$possible : PossibleCellValue( $zone : zone, $value : value, $col : col, $row : row)
+
+		# the not operator only causes this when clause to resolve to true when there are not
+		# any other PCVs with the same column and value as $possible
+		not (PossibleCellValue( col == $col, value == $value ))
+	then
+		retract($possible);
+		insert (new ResolvedCellValue($possible));
+
+		# insert a new String into the working memory describing in detail what we have done
+		insert ("BaseTest: rule #7 determined ("+$row+","+$col+") is "+$value+" as this is the only possible cell in the column that can have this value");
+end
+
+/**
+ * This rule checks for the situation when it is only possible for one cell of a zone in the Grid to contain
+ * a particular value, i.e. there is exactly one PossibleCellValue with a given zone and a given column.
+ * In this case, this cell must actually contain the value so we remove the single PossibleCellValue
+ * and replace it with an equivalent ResolvedCellValue.
+ */
+rule "BaseTest: #08 If a PossibleCellValue only appears once in a zone, then this must be the ResolvedCellValue"
+	agenda-group "BaseTest"
+    salience 30
+   	when		
+		# matches all PCVs in the grid, and stores them in the $possible local variable		
+		$possible : PossibleCellValue( $zone : zone, $value : value, $col : col, $row : row)
+
+		# the not operator only causes this when clause to resolve to true when there are not
+		# any other PCVs with the same column and value as $possible
+		not (PossibleCellValue( zone == $zone, value == $value ))
+	then
+		retract($possible);
+		insert (new ResolvedCellValue($possible));
+
+		# insert a new String into the working memory describing in detail what we have done
+		insert ("BaseTest: rule #8 determined ("+$row+","+$col+") is "+$value+" as this is the only possible cell in the zone that can have this value");
+end
+
+/**
+ * This rule looks for a situation where we have two cells in a zone of the grid which are in the 
+ * same column but different rows where each of the two cells contains exactly two possible values 
+ * and this pair of values is the same in both the cells. In this situation, while we do not 
+ * know which way round the two values should be assigned to the two cells, we do know that the 
+ * two values must be assigned to these two cells and therefore we remove the possibility of them 
+ * being present in any other cells in this zone.
+ */
+rule "BaseTest: #09 if a pair of cells exists in the same zone and the same column but different rows containing the same pair of possible values then elimnate these two possible values from anywhere else in the zone"
+	agenda-group "BaseTest"
+	salience 20
+	when
+	    # match all PCVs and store as $possible1
+		$possible1 : PossibleCellValue( $zone1 : zone, $val1 : value, $row1 : row, $col1 : col )
+		
+		# match any PCVs with the same value and in the same zone and column but in a different row to $possible1
+		$possible2 :PossibleCellValue( zone == $zone1, value == $val1, $row2 : row != $row1, $col2 : col)
+		
+		# match any PCV in the same location as $possible1 with a different value to $possible1
+		$possible3 : PossibleCellValue(row == $row1, col == $col1, $val3 : value )
+		
+		# match any PCV in the same location as $possible2 with the same value as $possible3
+		$possible4 : PossibleCellValue(row == $row2, col == $col2, value == $val3 )
+		
+		# check there is not a third PCV in the same location as $possible1 with a different value to $possible1 or $possible3
+		not ( PossibleCellValue( row == $row1, col == $col1, value != $val1, value != $val3 ) )
+		
+		# check there is not a third PCV in tne same location as $possible2 with a different value to $possible1 or $possible3
+		not ( PossibleCellValue( row == $row2, col == $col2, value != $val1, value != $val3 ) )
+		
+		# match any other PCVs in the same zone as $possible1 with the same value 
+		$possible : PossibleCellValue( zone == $zone1, value == $val1)
+	then
+		retract($possible);
+
+		# insert a new String into the working memory describing in detail what we have done
+		insert ("BaseTest: rule #9 fired, removing value "+$possible.getValue()+" as a possibility from "+$possible.getRow()+","+$possible.getCol()+" because the values of "+$val1+" and "+$val3+" must be in the cells "+$row1+","+$col1+" and "+$row2+","+$col2);
+end
+
+/**
+ * This rule looks for a situation where we have two cells in a zone of the grid which are in the 
+ * same row but different colums where each of the two cells contains exactly two possible values 
+ * and this pair of values is the same in both the cells. In this situation, while we do not 
+ * know which way round the two values should be assigned to the two cells, we do know that the 
+ * two values must be assigned to these two cells and therefore we remove the possibility of them 
+ * being present in any other cells in this zone.
+ */
+rule "BaseTest: #10 if a pair of cells exists in the same zone and the same row but different columns containing the same pair of possible values then elimnate these two possible values from anywhere else in the zone"
+	agenda-group "BaseTest"
+	salience 20
+	when
+	    # match all PCVs and store as $possible1
+		$possible1 : PossibleCellValue( $zone1 : zone, $val1 : value, $row1 : row, $col1 : col )
+		
+		# match any PCVs with the same value and in the same zone and column but in a different row to $possible1
+		$possible2 :PossibleCellValue( zone == $zone1, value == $val1, $row2 : row, $col2 : col != $col1)
+		
+		# match any PCV in the same location as $possible1 with a different value to $possible1
+		$possible3 : PossibleCellValue(row == $row1, col == $col1, $val3 : value )
+		
+		# match any PCV in the same location as $possible2 with the same value as $possible3
+		$possible4 : PossibleCellValue(row == $row2, col == $col2, value == $val3 )
+		
+		# check there is not a third PCV in the same location as $possible1 with a different value to $possible1 or $possible3
+		not ( PossibleCellValue( row == $row1, col == $col1, value != $val1, value != $val3 ) )
+		
+		# check there is not a third PCV in tne same location as $possible2 with a different value to $possible1 or $possible3
+		not ( PossibleCellValue( row == $row2, col == $col2, value != $val1, value != $val3 ) )
+		
+		# match any other PCVs in the same zone as $possible1 with the same value 
+		$possible : PossibleCellValue( zone == $zone1, value == $val1)
+	then
+		retract($possible);
+
+		# insert a new String into the working memory describing in detail what we have done
+		insert ("BaseTest: rule #10 fired, removing value "+$possible.getValue()+" as a possibility from "+$possible.getRow()+","+$possible.getCol()+" because the values of "+$val1+" and "+$val3+" must be in the cells "+$row1+","+$col1+" and "+$row2+","+$col2);
+end
+
+
+/**
+ * This rule cleans up any guesses left over from the guessing loop as the loop must have resolved 
+ * a cell which invalidates the previous potential guesses
+ */
+rule "BaseTest: Rule #00 Retract All Guesses"
+   agenda-group "BaseTest"
+   salience 100
+	when
+		$guess : GuessedCellValue( $value1 : value, $col1 : col, $row1 : row)
+	then
+		retract($guess);
+		insert ("BaseTest: retract all Guesses: V" + $guess.getValue() + ":R"+ $guess.getRow() + ":C"+ $guess.getCol());
+end
+
+
+/**
+ * The Validator agenda-group defines a set of rules that can be used to validate whether a valid Suoku solution
+ * has been produced or not. It expects to have objects of type BaseCell, PossibleCellValue and ResolvedCellValue
+ * inserted into the working memory and will then check that only a single ResolvedCellValue exists
+ * in a nxn Sudoku grid for each row, column and mxm zone.
+ *
+ * Any status conditions discovered are inserted into the working memeory.
+ *
+ */
+
+/**
+ * Checks for two ResolvedCellValues with both the same value and the same row property
+ * Enters a confilct status if there is one
+ */
+rule "Validator: #01 There should not be two ResolvedCellValues with the same value in the same row"
+   agenda-group "Validator"
+	when
+	    # Matches all ResolvedCellValues in the working memory and stores the row and the value for each in two local variables
+		$resolved1 : ResolvedCellValue($resolved1Row : row, $resolved1Value : value)
+		
+		# Matches any other ResolvedCellValues that have the same row and the same value as these two local variables
+		$resolved2 : ResolvedCellValue (row == $resolved1Row, value == $resolved1Value)
+	then
+	    # Enter a conflict
+		insert(new SudokuStatusConflict ("There are two cells on the same row with the same value " + $resolved1.getValue() + " at ("+$resolved1.getRow()+","+$resolved1.getCol()+") and ("+$resolved2.getRow()+","+$resolved2.getCol()+")"));
+     	insert("Validator " + "There are two cells on the same row with the same value " + $resolved1.getValue() + " at ("+$resolved1.getRow()+","+$resolved1.getCol()+") and ("+$resolved2.getRow()+","+$resolved2.getCol()+")");
+end
+
+/**
+ * Checks for two ResolvedCellValues with both the same value and the same column property
+ * Enters a confilct status if there is one
+ */
+rule "Validator: #02 There should not be two ResolvedCellValues with the same value in the same column"
+   agenda-group "Validator"
+	when
+	    # Matches all ResolvedCellValues in the working memory and stores the column and the value for each in two local variables
+		$resolved1 : ResolvedCellValue($resolved1Col : col, $resolved1Value : value)
+
+		# Matches any other ResolvedCellValues that have the same column and the same value as these two local variables
+		$resolved2 : ResolvedCellValue (col == $resolved1Col, value == $resolved1Value)
+	then
+	    # Enter a conflict
+		insert(new SudokuStatusConflict ("There are two cells on the same column with the same value at ("+$resolved1.getRow()+","+$resolved1.getCol()+") and ("+$resolved2.getRow()+","+$resolved2.getCol()+")"));
+		insert("Validator: There are two cells on the same column with the same value at ("+$resolved1.getRow()+","+$resolved1.getCol()+") and ("+$resolved2.getRow()+","+$resolved2.getCol()+")");
+end
+
+/**
+ * Checks for two ResolvedCellValues with both the same value and the same zone property
+ */
+rule "Validator: #03 There should not be two ResolvedCellValues with the same value in the same zone"
+   agenda-group "Validator"
+	when
+	    # Matches all ResolvedCellValues in the working memory and stores the zone and the value for each in two local variables
+		$resolved1 : ResolvedCellValue($resolved1Zone : zone, $resolved1Value : value)
+
+		# Matches any other ResolvedCellValues that have the same zone and the same value as these two local variables
+		$resolved2 : ResolvedCellValue (zone == $resolved1Zone, value == $resolved1Value)
+	then
+		insert(new SudokuStatusConflict ("There are two cells in the same zone " + $resolved1.getValue( ) + "with the same value at ("+$resolved1.getRow()+","+$resolved1.getCol()+") and ("+$resolved2.getRow()+","+$resolved2.getCol()+")"));
+		insert("Validator: There are two cells in the same zone with the same value " + $resolved1.getValue() + " at ("+$resolved1.getRow()+","+$resolved1.getCol()+") and ("+$resolved2.getRow()+","+$resolved2.getCol()+")");
+end
+/**
+ * Check for base cells have a possible cell value this is an indication of an 
+ * unresolved cell error 
+ */
+rule "Validator: #04 There should not be any basecells that have no resolved but still have possible cells"
+   agenda-group "Validator"
+	when
+	    # Run against all BaseCells in the working memory
+		$base : BaseCell($baseRow : row, $baseCol : col)
+		not (ResolvedCellValue (col == $baseCol, row==$baseRow))
+		PossibleCellValue (col == $baseCol, row==$baseRow)
+	then
+		insert(new SudokuStatusUnresolved ("Validator non-resolved row remains at ("+$base.getRow()+","+$base.getCol()+")" ,$base));
+     	insert("Validator non-resolved row remains at ("+$base.getRow()+","+$base.getCol()+")");
+end
+/**
+ * Check that all base cells have either a resolved or possible cell remaining
+ * If this is the case then the cell has no possible value which is a conflict error 
+ */
+rule "Validator: #01 Every basecells should  be resolved or possible cells"
+   agenda-group "Validator"
+	when
+	    # Run against all BaseCells in the working memory
+		$base : BaseCell($baseRow : row, $baseCol : col)
+		not (ResolvedCellValue (col == $baseCol, row==$baseRow)
+		|| PossibleCellValue (col == $baseCol, row==$baseRow))
+	then
+		insert(new SudokuStatusConflict("Validator: unresolveable row at ("+$base.getRow()+","+$base.getCol()+")"));
+     	insert("Validator: unresolveable row at ("+$base.getRow()+","+$base.getCol()+")");
+end
+/**
+ * Checks that there are no previous errors
+ * Enters a solved status row if this is the case to trigger the status listner
+ */
+rule "Validator: Final validation"
+   agenda-group "Validator"
+   salience -20
+	when
+		# No Conflicts in memory
+		 not ( SudokuStatusConflict())
+		# No unresolved cells in memory
+		 not( SudokuStatusUnresolved() )
+	then
+	    # We must be done
+		insert(new SudokuStatusSolved("Validator: No Errors at all"));
+		# track the action
+		insert("Validator: No errors at all " );
+end
+
+/**
+ * The 	agenda-group "GuessTesting" is a guess modifid case of the basic set of rules needed to solve a sudoku problem
+ * The set is modified to remember any deletes and inserts that occur so they can be reversed in the "ReverseGuess" agenda-group.
+ */
+
+/**
+ * This rule checks for the situation where a given Cell in the Sudoku Grid has been assigned 
+ * a definate ResolvedCellValue (i.e. we know what the value in this cell of the Grid is) and
+ * removes any other possible values from this cell (i.e. instances of PossibleCellValue 
+ * with the same row and column.
+ */
+rule "GuessTesting: #01 once a specific cell has a ResolvedCellValue, remove all the other PossibleCellValues for the same cell"
+	# this rule requires a high salience so that, when it is activated it is executed, as soon as a 
+	# ResolvedCellValue is set, we need to clear out the PossibleCellValues for the same cell location, 
+	# otherwise other rules misfire - a good example of a valid use for salience
+	agenda-group "GuessTesting"
+	salience 50 
+	when
+	    # matches all ResolvedCellValues (RCVs) in the grid, and stores them in the $resolved local variable
+	    # note that we also need to store the row and column for $resolved in $resolvedRow and $resolvedColum
+	    # so that the second part of the when clause can access them
+		$resolved : ResolvedCellValue($resolvedRow : row, $resolvedCol : col)
+		
+		# matches any PossibleCellValues (PCVs) in the grid with the same row and column as $resolved
+		$possible : PossibleCellValue(row == $resolvedRow, col == $resolvedCol)
+		(GuessedCellValue(active == true))
+	then
+      		# insert a new RemovedCellValue with the posible value recorded
+	    insert( new RemovedCellValue($possible));
+		# remove the matching PCVs stored in $possible
+		retract($possible);
+		
+		# insert a new String into the working memory describing in detail what we have done
+		insert ("GuessTesting: rule #1 cleared the other PossibleCellValues for ("+$resolved.getRow()+","+$resolved.getCol()+") as a ResolvedCellValue of "+$resolved.getValue()+" exists for this cell.");
+end
+
+/** 
+ * This rule checks for the situation where a given Cell in the SudokuGrid only has 
+ * one PossibleCellValue assigned to its row and column. Once we have this situation, we 
+ * now that this must be the correct value for the cell so we remove the single PossibleCellValue
+ * and replace it with an equivalent ResolvedCellValue.
+ */
+rule "GuessTesting: #02 If a cell has only a single PossibleCellValue, remove it and replace it with the equivalent ResolvedCellValue"
+	agenda-group "GuessTesting"
+	salience 35
+	when
+		# macthes all PCVs in the Grid, stores them in $possible
+		$possible : PossibleCellValue ( $possibleRow : row, $possibleCol : col, $possibleValue : value )
+		
+		# the not operator only causes this when clause to resolve to true when there are not
+		# any other PCVs with the same row and column but different values to $possible
+		not ( PossibleCellValue ( row == $possibleRow, col == $possibleCol, value != $possibleValue ) )
+		(GuessedCellValue(active == true))
+	then
+		# create a new ResolvedCellValue with the same row, column and value into the working memory
+	    resolved = new ResolvedCellValue( $possible);
+		# insert a new ResolvedCellValue with the same row, column and value into the working memory
+	    insert( resolved );
+      		# insert a new RemovedCellValue with the posible and resolved values recorded
+	    insert( new RemovedCellValue($possible , resolved ));
+		# remove $possible from the working memory
+		retract($possible);
+		
+		# insert a new String into the working memory describing in detail what we have done
+		insert ("GuessTesting: rule #2 changed the only PossibleCellValue at ("+$possible.getRow()+","+$possible.getCol()+") to a ResolvedCellValue with the value of "+$possible.getValue());
+end
+
+/**
+ * This rule checks for the situation where a row in the Grid has a ResolvedCellValue in it. In 
+ * this case we know that the value can not occur in any of the other cells in the same row in 
+ * the grid, so we look for any PossibleCellValues with the same row and remove them.
+ */
+rule "GuessTesting: #03 If a row has a ResolvedCellValue in it, remove this value as a PossibleCellValue from all other cells in the same row"
+	agenda-group "GuessTesting"
+  	salience 40
+  	when
+  		# matches all RCVs in the grid, and stores them in the $resolved local variable		
+		$resolved : ResolvedCellValue( $resolvedRow : row, $resolvedValue : value )
+		
+		# matches all the PCVs in the grid in the same row with the same value as $resolved
+		$possible : PossibleCellValue( row == $resolvedRow, value == $resolvedValue )
+		(GuessedCellValue(active == true))
+	then
+      		# insert a new RemovedCellValue with the posible value recorded
+	    insert( new RemovedCellValue($possible));
+		retract($possible);
+
+		# insert a new String into the working memory describing in detail what we have done
+		insert ("GuessTesting: rule #3 determined the value at ("+$possible.getRow()+","+$possible.getCol()+") could not be "+$possible.getValue()+" as this value already exists in the same row at ("+$resolved.getRow()+","+$resolved.getCol()+")");
+end
+
+/**
+ * This rule checks for the situation where a column in the Grid has a ResolvedCellValue in it. In 
+ * this case we know that the value can not occur in any of the other cells in the same column in 
+ * the grid, so we look for any PossibleCellValues with the same column and remove them.
+ */
+rule "GuessTesting: #04 If a column has a ResolvedCellValue in it, remove this value as a PossibleCellValue from all other cells in the same column"
+	agenda-group "GuessTesting"
+  	salience 40
+    when		
+  		# matches all RCVs in the grid, and stores them in the $resolved local variable		
+		$resolved : ResolvedCellValue( $resolvedCol : col, $resolvedValue : value )
+
+		# matches all the PCVs in the grid in the same column with the same value as $resolved
+		$possible : PossibleCellValue( col == $resolvedCol, value == $resolvedValue )
+		(GuessedCellValue(active == true))
+	then
+      		# insert a new RemovedCellValue with the posible value recorded
+	    insert( new RemovedCellValue($possible));
+		retract($possible);
+
+		# insert a new String into the working memory describing in detail what we have done
+		insert ("GuessTesting: rule #4 determined the value at ("+$possible.getRow()+","+$possible.getCol()+") could not be "+$possible.getValue()+" as this value already exists in the same column at ("+$resolved.getRow()+","+$resolved.getCol()+")");
+end
+
+/**
+ * This rule checks for the situation where a zone in the Grid has a ResolvedCellValue in it. In 
+ * this case we know that the value can not occur in any of the other cells in the same zone in 
+ * the grid, so we look for any PossibleCellValues with the same zone and remove them.
+ */
+rule "GuessTesting: #05 If a zone has a ResolvedCellValue in it, remove this value as a PossibleCellValue from all other cells in the same zone"
+	agenda-group "GuessTesting"
+  	salience 40
+ 	when		
+  		# matches all RCVs in the grid, and stores them in the $resolved local variable		
+		$resolved : ResolvedCellValue( $resolvedZone : zone, $resolvedValue : value )
+
+		# matches all the PCVs in the grid in the same zone with the same value as $resolved
+		$possible : PossibleCellValue( zone == $resolvedZone, value == $resolvedValue )
+		(GuessedCellValue(active == true))
+	then
+      		# insert a new RemovedCellValue with the posible value recorded
+	    insert( new RemovedCellValue($possible));
+		retract($possible);
+
+	    # insert a new String into the working memory describing in detail what we have done
+		insert ("GuessTesting: rule #5 determined the value at ("+$possible.getRow()+","+$possible.getCol()+") could not be "+$possible.getValue()+" as this value already exists in the same zone at ("+$resolved.getRow()+","+$resolved.getCol()+")");
+end
+
+/**
+ * This rule checks for the situation when it is only possible for one cell of a row in the Grid to contain
+ * a particular value, i.e. there is exactly one PossibleCellValue with a given value and a given row.
+ * In this case, this cell must actually contain the value so we remove the single PossibleCellValue
+ * and replace it with an equivalent ResolvedCellValue.
+ */
+rule "GuessTesting: #06 If a PossibleCellValue only appears once in a row, then this must be the ResolvedCellValue"
+	agenda-group "GuessTesting"
+    salience 30
+	when
+		# matches all PCVs in the grid, and stores them in the $possible local variable		
+		$possible : PossibleCellValue( $zone : zone, $value : value, $col : col, $row : row)
+
+		# the not operator only causes this when clause to resolve to true when there are not
+		# any other PCVs with the same row and value as $possible
+		not (PossibleCellValue( row == $row, value == $value ))
+		(GuessedCellValue(active == true))
+	then
+		# create a new ResolvedCellValue with the same row, column and value into the working memory
+	    resolved = new ResolvedCellValue( $possible);
+		# insert a new ResolvedCellValue with the same row, column and value into the working memory
+	    insert( resolved );
+      		# insert a new RemovedCellValue with the posible and resolved values recorded
+	    insert( new RemovedCellValue($possible , resolved ));
+		retract($possible);
+
+		# insert a new String into the working memory describing in detail what we have done
+		insert ("GuessTesting: rule #6 determined ("+$row+","+$col+") is "+$value+" as this is the only possible cell in the row that can have this value");
+end
+
+/**
+ * This rule checks for the situation when it is only possible for one cell of a column in the Grid to contain
+ * a particular value, i.e. there is exactly one PossibleCellValue with a given value and a given column.
+ * In this case, this cell must actually contain the value so we remove the single PossibleCellValue
+ * and replace it with an equivalent ResolvedCellValue.
+ */
+rule "GuessTesting: #07 If a PossibleCellValue only appears once in a column, then this must be the ResolvedCellValue"
+	agenda-group "GuessTesting"
+    salience 30
+  	when		
+		# matches all PCVs in the grid, and stores them in the $possible local variable		
+		$possible : PossibleCellValue( $zone : zone, $value : value, $col : col, $row : row)
+
+		# the not operator only causes this when clause to resolve to true when there are not
+		# any other PCVs with the same column and value as $possible
+		not (PossibleCellValue( col == $col, value == $value ))
+		(GuessedCellValue(active == true))
+	then
+		# create a new ResolvedCellValue with the same row, column and value into the working memory
+	    resolved = new ResolvedCellValue( $possible);
+		# insert a new ResolvedCellValue with the same row, column and value into the working memory
+	    insert( resolved );
+      		# insert a new RemovedCellValue with the posible and resolved values recorded
+	    insert( new RemovedCellValue($possible , resolved ));
+		retract($possible);
+
+		# insert a new String into the working memory describing in detail what we have done
+		insert ("GuessTesting: rule #7 determined ("+$row+","+$col+") is "+$value+" as this is the only possible cell in the column that can have this value");
+end
+
+/**
+ * This rule checks for the situation when it is only possible for one cell of a zone in the Grid to contain
+ * a particular value, i.e. there is exactly one PossibleCellValue with a given zone and a given column.
+ * In this case, this cell must actually contain the value so we remove the single PossibleCellValue
+ * and replace it with an equivalent ResolvedCellValue.
+ */
+rule "GuessTesting: #08 If a PossibleCellValue only appears once in a zone, then this must be the ResolvedCellValue"
+	agenda-group "GuessTesting"
+    salience 30
+   	when		
+		# matches all PCVs in the grid, and stores them in the $possible local variable		
+		$possible : PossibleCellValue( $zone : zone, $value : value, $col : col, $row : row)
+
+		# the not operator only causes this when clause to resolve to true when there are not
+		# any other PCVs with the same column and value as $possible
+		not (PossibleCellValue( zone == $zone, value == $value ))
+		(GuessedCellValue(active == true))
+	then
+		# create a new ResolvedCellValue with the same row, column and value into the working memory
+	    resolved = new ResolvedCellValue( $possible);
+		# insert a new ResolvedCellValue with the same row, column and value into the working memory
+	    insert( resolved );
+      		# insert a new RemovedCellValue with the posible and resolved values recorded
+	    insert( new RemovedCellValue($possible , resolved ));
+		retract($possible);
+
+		# insert a new String into the working memory describing in detail what we have done
+		insert ("GuessTesting: rule #8 determined ("+$row+","+$col+") is "+$value+" as this is the only possible cell in the zone that can have this value");
+end
+
+/**
+ * This rule looks for a situation where we have two cells in a zone of the grid which are in the 
+ * same column but different rows where each of the two cells contains exactly two possible values 
+ * and this pair of values is the same in both the cells. In this situation, while we do not 
+ * know which way round the two values should be assigned to the two cells, we do know that the 
+ * two values must be assigned to these two cells and therefore we remove the possibility of them 
+ * being present in any other cells in this zone.
+ */
+rule "GuessTesting: #09 if a pair of cells exists in the same zone and the same column but different rows containing the same pair of possible values then elimnate these two possible values from anywhere else in the zone"
+	agenda-group "GuessTesting"
+	salience 20
+	when
+	    # match all PCVs and store as $possible1
+		$possible1 : PossibleCellValue( $zone1 : zone, $val1 : value, $row1 : row, $col1 : col )
+		
+		# match any PCVs with the same value and in the same zone and column but in a different row to $possible1
+		$possible2 :PossibleCellValue( zone == $zone1, value == $val1, $row2 : row != $row1, $col2 : col)
+		
+		# match any PCV in the same location as $possible1 with a different value to $possible1
+		$possible3 : PossibleCellValue(row == $row1, col == $col1, $val3 : value )
+		
+		# match any PCV in the same location as $possible2 with the same value as $possible3
+		$possible4 : PossibleCellValue(row == $row2, col == $col2, value == $val3 )
+		
+		# check there is not a third PCV in the same location as $possible1 with a different value to $possible1 or $possible3
+		not ( PossibleCellValue( row == $row1, col == $col1, value != $val1, value != $val3 ) )
+		
+		# check there is not a third PCV in tne same location as $possible2 with a different value to $possible1 or $possible3
+		not ( PossibleCellValue( row == $row2, col == $col2, value != $val1, value != $val3 ) )
+		
+		# match any other PCVs in the same zone as $possible1 with the same value 
+		$possible : PossibleCellValue( zone == $zone1, value == $val1)
+		(GuessedCellValue(active == true))
+	then
+      		# insert a new RemovedCellValue with the posible value recorded
+	    insert( new RemovedCellValue($possible));
+		retract($possible);
+
+		# insert a new String into the working memory describing in detail what we have done
+		insert ("GuessTesting: rule #9 fired, removing value "+$possible.getValue()+" as a possibility from "+$possible.getRow()+","+$possible.getCol()+" because the values of "+$val1+" and "+$val3+" must be in the cells "+$row1+","+$col1+" and "+$row2+","+$col2);
+end
+
+/**
+ * This rule looks for a situation where we have two cells in a zone of the grid which are in the 
+ * same row but different colums where each of the two cells contains exactly two possible values 
+ * and this pair of values is the same in both the cells. In this situation, while we do not 
+ * know which way round the two values should be assigned to the two cells, we do know that the 
+ * two values must be assigned to these two cells and therefore we remove the possibility of them 
+ * being present in any other cells in this zone.
+ */
+rule "GuessTesting: #10 if a pair of cells exists in the same zone and the same row but different columns containing the same pair of possible values then elimnate these two possible values from anywhere else in the zone"
+	agenda-group "GuessTesting"
+	salience 20
+	when
+	    # match all PCVs and store as $possible1
+		$possible1 : PossibleCellValue( $zone1 : zone, $val1 : value, $row1 : row, $col1 : col )
+		
+		# match any PCVs with the same value and in the same zone and column but in a different row to $possible1
+		$possible2 :PossibleCellValue( zone == $zone1, value == $val1, $row2 : row, $col2 : col != $col1)
+		
+		# match any PCV in the same location as $possible1 with a different value to $possible1
+		$possible3 : PossibleCellValue(row == $row1, col == $col1, $val3 : value )
+		
+		# match any PCV in the same location as $possible2 with the same value as $possible3
+		$possible4 : PossibleCellValue(row == $row2, col == $col2, value == $val3 )
+		
+		# check there is not a third PCV in the same location as $possible1 with a different value to $possible1 or $possible3
+		not ( PossibleCellValue( row == $row1, col == $col1, value != $val1, value != $val3 ) )
+		
+		# check there is not a third PCV in tne same location as $possible2 with a different value to $possible1 or $possible3
+		not ( PossibleCellValue( row == $row2, col == $col2, value != $val1, value != $val3 ) )
+		
+		# match any other PCVs in the same zone as $possible1 with the same value 
+		$possible : PossibleCellValue( zone == $zone1, value == $val1)
+		(GuessedCellValue(active == true))
+	then
+      		# insert a new RemovedCellValue with the posible value recorded
+	    insert( new RemovedCellValue($possible));
+		retract($possible);
+
+		# insert a new String into the working memory describing in detail what we have done
+		insert ("GuessTesting: rule #10 fired, removing value "+$possible.getValue()+" as a possibility from "+$possible.getRow()+","+$possible.getCol()+" because the values of "+$val1+" and "+$val3+" must be in the cells "+$row1+","+$col1+" and "+$row2+","+$col2);
+end
+/**
+ * The 	agenda-group "GuessSetup" sets up the starting conditions for guess testing
+ * Which are as follows:
+ * Find a cell that has 2 or more possible cell values, and that hasn't been guessed
+ * Remove a possible value and insert a planned guess cell
+ * Replace all the other possibles with guesses.
+ */
+/**
+ * Find a cell that has exactly 2 possible cell values, and that hasn't been guessed
+ * set it up for testing
+ */
+rule "GuessSetup: rule #01 If there is a cell with only two possible values that hasn't been guessed, setup for guessing"
+   agenda-group "GuessSetup"
+   salience 20
+	when
+		$possible1 : PossibleCellValue( $value1 : value, $col1 : col, $row1 : row)
+		$possible2 : PossibleCellValue( $value2 : value, value != $value1
+		, col == $col1, row == $row1)
+		not (PossibleCellValue( value != $value2, value != $value1,col == $col1, row == $row1) )
+		not (GuessedCellValue(planned == true))
+		not (GuessedCellValue(value == $value1,col == $col1, row == $row1))
+	then
+		insert( new GuessedCellValue( $possible1) );
+	    retract($possible1);
+		insert("GuessSetup: Rule #01 fired" );
+end
+/**
+ * Find a cell that has more then 2 possible cell values, and that hasn't been guessed
+ * set it up for testing
+ */
+rule "GuessSetup: rule #02 If there is a cell with possible values and rule 01 didn't set up a guess, setup for guessing"
+   agenda-group "GuessSetup"
+   salience 10
+	when
+		$possible1 : PossibleCellValue( $value1 : value, $col1 : col, $row1 : row)
+		$possible2 : PossibleCellValue( $value2 : value, value != $value1
+		, col == $col1, row == $row1)
+		not (GuessedCellValue(planned == true))
+		not (GuessedCellValue(value == $value1,col == $col1, row == $row1))
+	then
+		insert( new GuessedCellValue( $possible1) );
+	    retract($possible1);
+		insert("GuessSetup: Rule #02 fired" );
+end
+/**
+ * Find a cell that has more then 2 possible cell values, and that hasn't been guessed
+ * set it up for testing
+ */
+rule "GuessSetup: rule #03 if you identified a cell to guess remove the other possible guesses"
+   agenda-group "GuessSetup"
+	when
+		$possible1 : PossibleCellValue( $zone1 : zone, $value1 : value, $col1 : col, $row1 : row)
+		$firstGuess : GuessedCellValue( zone == $zone1, col == $col1,  row == $row1,planned == true)
+	then
+		insert( new GuessedCellValue( $possible1) );
+	    retract($possible1);
+		
+		insert("GuessSetup: Rule #03 fired" );
+end
+/**
+ * The 	agenda-group "GuessSelection" identifies one of the planned guesses as the active guess
+ */
+/**
+ * Rule 1 pick a random planned guess when there is no active guess and make it active
+ * and add a resolve cell to the memory
+ */
+rule "GuessSelection: Rule #01 if you are guessing and have no active row pick one as the active row"
+   agenda-group "GuessSelection"
+   salience 20
+	when
+		$firstGuess : GuessedCellValue( $zone1 : zone, $value1 : value, $col1 : col, $row1 : row,planned == true, $possible : possibleCellRemoved)
+		not( GuessedCellValue( zone == $zone1, col == $col1,  row == $row1,value != $value1, active == true) )
+	then
+    	$firstGuess.setState( GuessedCellValue.GUESSING_STATUS_ACTIVE); 
+		update($firstGuess);
+		insert( $possible);
+		insert("GuessSelection: Rule #01 fired to activate guess :" + $value1+ ":" + $row1 + ":" + $col1 + ":");
+end
+/**
+ * The 	agenda-group "GuessSelectionError" cleans out the current active guess as it has been identified as an 
+ * Error. 
+ */
+/**
+ * "GuessSelectionError"  step 1. put in a possible row so that the listner can pick up its removal in step 2 
+ */
+
+rule "GuessSelectionError: Step #1 make sure a possible row exists for the guess to be reomved for the listener"
+   agenda-group "GuessSelectionError"
+   salience 20
+	when
+		$guess : GuessedCellValue( $possible : possibleCellRemoved , $value : value, $row : row, $col:col, active == true)
+		not(PossibleCellValue ( value == $value, row == $row, col == $col))
+	then
+		insert($possible );
+		insert("GuessSelectionError: Step #1 make sure a possible row exists for the guess to be reomved for the listener : added possible:"+ $guess.getValue() + ":R"+ $guess.getRow() + ":C"+ $guess.getCol());
+end
+/**
+ * "GuessSelectionError"  step 2. remove the guess and the associated possible row. 
+ */
+rule "GuessSelectionError: Step #2 retract the guess and the possible row"
+   agenda-group "GuessSelectionError"
+   salience 10
+	when
+		$guess : GuessedCellValue( $possible : possibleCellRemoved , $value : value, $row : row, $col:col, active == true)
+		PossibleCellValue ( value == $value, row == $row, col == $col)
+	then
+		retract($guess);
+		retract($possible );
+		insert("GuessSelectionError: Step #2 previous guess was wrong : removed guess V:"+ $guess.getValue() + ":R"+ $guess.getRow() + ":C"+ $guess.getCol());
+end
+/**
+ * The 	agenda-group "GuessSelectionErrorOneCellRemains" identifies the only remaining guess in the 
+ * cell currently being tested. When all other possiblities have been eliminated and sets it as possible
+ * so that the base loop can be rerun. 
+ */
+rule "GuessSelectionErrorOneCellRemains #1 but add both as possible"
+   agenda-group "GuessSelectionErrorOneCellRemains"
+    when
+		$guess : GuessedCellValue( $possible : possibleCellRemoved , previous == false)
+	then
+		insert($possible );
+		insert("GuessSelectionErrorOneCellRemains down to 1 put in possible guess V:"+ $guess.getValue() + ":R"+ $guess.getRow() + ":C"+ $guess.getCol());
+end
+
+/**
+ * The 	agenda-group "ReverseGuess" reverses the actions of "GuessTesting" 
+ */
+/**
+ * ReverseGuess: Step 01 reverse actions that just removed a possible cell because of a guess
+ */
+rule "ReverseGuess: Step #01 Reverse removed possible cells"
+   agenda-group "ReverseGuess"
+   salience 20
+	when
+   $removed : RemovedCellValue($possible: possibleCellRemoved, 
+   hasResolvedCell == false,
+   $row: row, $col: col, $value:value)
+	then
+	    retract($removed);
+	    insert($possible);
+	    update($possible);
+		insert("Reverse Guess: Step #02 Reversing the possible cell of value " + $possible.getValue() + ":R"+ $possible.getRow() + ":C"+ $possible.getCol());
+end
+
+/**
+ * ReverseGuess: Step 02 reverse actions that add a resolved cell and removed a possible cell because of a guess
+ */
+rule "ReverseGuess: Step #02 Reverse removed possible cells and added resolved cells"
+   agenda-group "ReverseGuess"
+   salience 20
+	when
+   $removed : RemovedCellValue($possible: possibleCellRemoved
+   		, hasResolvedCell == true
+   		, $resolved : resolvedCell)
+	then
+	    retract($removed);
+	    retract($resolved);
+	    insert($possible);
+	    update($possible);
+		insert("Reverse Guess: Step #02 Reversing the possible and the resolved with of V" + $possible.getValue() + ":R"+ $possible.getRow() + ":C"+ $possible.getCol());
+end
+
+/**
+ * The 	agenda-group "CleanupUnsolved" cleans up after an unsolved loop
+ */
+/**
+ * CleanupUnsolved: Step 01 mare all previous guesses as previous
+ * they are retained briefly to make sure that the same cell isn't repeatedly guessed
+ */
+rule "CleanupUnsolved: Step #01 update non-previous guesses as previous"
+   agenda-group "CleanupUnsolved"
+	when
+		$guess : GuessedCellValue( previous == false,$possible : possibleCellRemoved)
+	then
+	$guess.setState( GuessedCellValue.GUESSING_STATUS_PREVIOUS);
+		update($guess);
+		insert($possible );
+		insert("CleanupUnsolved: Step #01 update non-previous guesses as previous V" + $guess.getValue() + ":R"+ $guess.getRow() + ":C"+ $guess.getCol());
+end
+/**
+ * The 	agenda-group "CleanupCorrectGuess" cleans up after an guess that solves the puzzle
+ */
+/**
+ * Step #01 put back the possible cells for the current guesses
+ */
+ rule "CleanupCorrectGuess: Step #01 Reverse non-previous guess cells"
+   agenda-group "CleanupCorrectGuess"
+   salience 20
+	when
+    GuessedCellValue($possible: possibleCellRemoved, previous == false)
+	then
+	   insert($possible);
+	   insert("CleanupCorrectGuess: Step 1 Reversing the possible from Guess of V" + $possible.getValue() + ":R"+ $possible.getRow() + ":C"+ $possible.getCol());
+end
+/**
+ * Step #02 remove the possible cell for any guess that is tested and has a resolved value
+ */
+ 
+rule "CleanupCorrectGuess: Step 2 remove non active resolutions with resolved values"
+# This works because the the guess all ready is a possible 
+# and needs to be flipped again to be visible to the listener
+   agenda-group "CleanupCorrectGuess"
+	salience 10
+	when
+		$guess : GuessedCellValue( $value1 : value, $col1 : col, $row1 : row,tested == true,$possible : possibleCellRemoved)
+		$resolved : ResolvedCellValue( value == $value1, row == $row1, col == $col1)
+	then
+		insert($possible);
+		retract($resolved );
+		retract($guess);
+		insert("CleanupCorrectGuess: Step 2 Reverse Guess remove non active resolutions with resolved values: V" + $guess.getValue() + ":R"+ $guess.getRow() + ":C"+ $guess.getCol());
+end
+/**
+ * Step #03 remove the possible cell for any non active guesses 
+ */
+rule "CleanupCorrectGuess: Step #03 remove the possible for the non-active guesses in the current cell"
+# This works because the the guess all ready is a possible 
+# and needs to be flipped again to be visible to the listener
+   agenda-group "CleanupCorrectGuess"
+	when
+	    # ID the guessed value as it is right
+		GuessedCellValue( $value1 : value, $col1 : col, $row1 : row, active == true)
+		# ID the non-active guess and thier possible values in the same cell
+		$guess : GuessedCellValue(  value != $value1, col ==  $col1 , row == $row1 , active == false, $possible : possibleCellRemoved)
+	then
+	    # remove the non-active guess's possible fact which was added in step 01 so the listener is triggered by the removal
+		retract($possible);
+		# remove the non-active guess
+		retract($guess);
+		insert("CleanupCorrectGuess: Step 3 remove the possible for the non-active guesses in the current cell: V" + $guess.getValue() + ":R"+ $guess.getRow() + ":C"+ $guess.getCol());
+end
+/**
+ * The 	agenda-group "ReverseErrors" cleans up the state error messages from a previous validation run
+ * before running another set of tests
+ */
+ /**
+ * Remove all conflicts as these are identfied by the error which is being reversed
+ */
+rule "ReverseErrors: Step #01 Reverse Conflicts Errors"
+   agenda-group "ReverseErrors"
+    when
+		$conflict : SudokuStatusConflict()
+	then
+		retract($conflict );
+		insert("ReverseErrors: Step #01 Reversing a conflict error" + $conflict.toString());
+end
+ /**
+ * Remove all unresolved error if there is now a resolved row
+ */
+rule "ReverseErrors: Step #02 Reverse Unsolved Errors"
+   agenda-group "ReverseErrors"
+   salience -20
+	when
+		$unsolved : SudokuStatusUnresolved($base : base,$baseCol:col, $baseRow:row)
+		ResolvedCellValue (col == $baseCol, row==$baseRow)
+	then
+		retract($unsolved);
+		insert("ReverseErrors: Step #02 Reversing a unsolved error: V" +  ":R"+ $baseRow + ":C"+ + $baseCol);
+end
+/**
+ * The 	agenda-group "ArchiveGuesses" marks the current guesses as previous
+ */
+ /**
+ * Mark all current guessed cells previous as the previous guesses didn't remove a cell
+ */
+rule "ArchiveGuesses: Step #01 archive guesses"
+   agenda-group "ArchiveGuesses"
+	when
+		$guess : GuessedCellValue( previous == false)
+	then
+		$guess.setState( GuessedCellValue.GUESSING_STATUS_PREVIOUS); 
+		update($guess);		
+		insert("ArchiveGuesses: Step #01 archive guesses : V" + $guess.getValue() + ":R"+ $guess.getRow() + ":C"+ $guess.getCol());
+end
+/**
+ * The 	agenda-group "BasicRevGuess" puts the possible cells back for the current guesses 
+ */
+rule "BasicRevGuess: Step #01 put back all the possible cells"
+   agenda-group "BasicRevGuess"
+	when
+		$guess : GuessedCellValue( $possible:possibleCellRemoved, previous == false)
+	then
+		insert($possible);
+		insert("BasicRevGuess: Step #01  insert possible for guess : V" + $possible.getValue() + ":R"+ $possible.getRow() + ":C"+ $possible.getCol());
+end

